/* Program: ex2-1.c
 * ---------------------------------------------------------------------
 * Solution to exercise 1, series 2.
 *
 * This program calculates and prints the length of the straight
 * line segment between two points (x1, y1) and (x2, y2).
 * It repeats this until the length is zero.
 * ---------------------------------------------------------------------
 * Nikolaos S. Papaspyrou (nickie@softlab.ntua.gr)
 * National Technical University of Athens
 * Department of Electrical Engineering
 * ---------------------------------------------------------------------
 * Course: Programming Techniques (2nd semester)
 * URL:    http://www.softlab.ntua.gr/~nickie/Courses/progtech/
 * ---------------------------------------------------------------------
 */


/* Header files */

#include <math.h>
#include <stdio.h>


/* Function that computes the length of a straight line segment */

double length (double x1, double y1, double x2, double y2)
{
    double dx = x1-x2;
    double dy = y1-y2;

    return sqrt(dx * dx + dy * dy);
}


/* Main program */

int main ()
{
    double x1, y1, x2, y2, l;

    do {
        printf("Give the coordinates of the first point:\n");
        printf("x1 = ");
        scanf("%lf", &x1);
        printf("y1 = ");
        scanf("%lf", &y1);
        printf("Give the coordinates of the second point:\n");
        printf("x2 = ");
        scanf("%lf", &x2);
        printf("y2 = ");
        scanf("%lf", &y2);

        l = length(x1, y1, x2, y2);

        printf("The length of this segment is %lf\n", l);
    } while (l > 0);

    return 0;
}
