/* Program: ex2-2.c
 * ---------------------------------------------------------------------
 * Solution to exercise 2, series 2.
 *
 * This program calculates and prints the area of the triangle
 * with vertices at points (x1, y1), (x2, y2) and (x3, y3).
 * It repeats this until the area is zero.
 * ---------------------------------------------------------------------
 * Nikolaos S. Papaspyrou (nickie@softlab.ntua.gr)
 * National Technical University of Athens
 * Department of Electrical Engineering
 * ---------------------------------------------------------------------
 * Course: Programming Techniques (2nd semester)
 * URL:    http://www.softlab.ntua.gr/~nickie/Courses/progtech/
 * ---------------------------------------------------------------------
 */


/* Header files */

#include <math.h>
#include <stdio.h>


/* Function that computes the length of a straight line segment */

double length (double x1, double y1, double x2, double y2)
{
    double dx = x1-x2;
    double dy = y1-y2;

    return sqrt(dx * dx + dy * dy);
}


/* Function that computes the area of a triangle */

double area (double x1, double y1, double x2, double y2, double x3, double y3)
{
    double a   = length(x2, y2, x3, y3);
    double b   = length(x1, y1, x3, y3);
    double c   = length(x1, y1, x2, y2);
    double tau = (a + b + c) / 2;

    return sqrt(tau * (tau - a) * (tau - b) * (tau - c));
}


/* Main program */

int main ()
{
    double x1, y1, x2, y2, x3, y3, a;

    do {
        printf("Give the coordinates of the first vertex:\n");
        printf("x1 = ");
        scanf("%lf", &x1);
        printf("y1 = ");
        scanf("%lf", &y1);
        printf("Give the coordinates of the second vertex:\n");
        printf("x2 = ");
        scanf("%lf", &x2);
        printf("y2 = ");
        scanf("%lf", &y2);
        printf("Give the coordinates of the third vertex:\n");
        printf("x3 = ");
        scanf("%lf", &x3);
        printf("y3 = ");
        scanf("%lf", &y3);

        a = area(x1, y1, x2, y2, x3, y3);

        printf("The area of this triangle is %lf\n", a);
    } while (a > 0);

    return 0;
}
