/* Program: ex2-3.c
 * ---------------------------------------------------------------------
 * Solution to exercise 3, series 2.
 *
 * This program fills a square matrix with random integer numbers
 * and prints statistics.
 * ---------------------------------------------------------------------
 * Nikolaos S. Papaspyrou (nickie@softlab.ntua.gr)
 * National Technical University of Athens
 * Department of Electrical Engineering
 * ---------------------------------------------------------------------
 * Course: Programming Techniques (2nd semester)
 * URL:    http://www.softlab.ntua.gr/~nickie/Courses/progtech/
 * ---------------------------------------------------------------------
 */


/* Header files */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>


/* Constants */

#define M 10
#define N 100


/* Function that fills the table with random values between 0 and M */

void makeTable (int r[N][N])
{
    int i, j;

    for (i = 0; i < N; i++)
        for (j = 0; j < N; j++)
            r[i][j] = rand() % (M+1);
}


/* Main program */

int main ()
{
    int    r[N][N];
    int    freq[M+1];
    double sumx, sumx2, m, sigma;
    int    i, j;

    /* Fill the table */

    makeTable(r);

    /*
        Calculate frequency, average (m) and standard deviation (sigma).
        Take advantage of the following transformation:

        m = sum(x) / N^2

        sigma = sqrt(sum((x - m)^2) / N^2)
              = sqrt(sum(x^2 - 2 x m + m^2) / N^2)
              = sqrt((sum(x^2) - 2 m sum(x) + N^2 m^2) / N^2)
              = sqrt((sum(x^2) - 2 N^2 m^2 + N^2 m^2) / N^2)
              = sqrt(sum(x^2) / N^2 - m^2)
    */

    sumx = sumx2 = 0;
    for (i = 0; i <= M; i++)
        freq[i] = 0;

    for (i = 0; i < N; i++)
        for (j = 0; j < N; j++) {
            int x = r[i][j];

            freq[x]++;
            sumx += x;
            sumx2 += x * x;
        }

    m = sumx / (N*N);
    sigma = sqrt(sumx2 / (N*N) - m*m);

    /* Print the results */

    for (i = 0; i <= M; i++)
        printf("freq(%d) = %d\n", i, freq[i]);

    printf("mean  = %lf\n", m);
    printf("stdev = %lf\n", sigma);

    return 0;
}
