/* Program: ex2-4.c
 * ---------------------------------------------------------------------
 * Solution to exercise 4, series 2.
 *
 * This program fills a square matrix with random integer numbers
 * calculates the standard deviation of these numbers and repeats
 * until this is below a given value, or a fixed number of tries
 * has been reached.
 * ---------------------------------------------------------------------
 * Nikolaos S. Papaspyrou (nickie@softlab.ntua.gr)
 * National Technical University of Athens
 * Department of Electrical Engineering
 * ---------------------------------------------------------------------
 * Course: Programming Techniques (2nd semester)
 * URL:    http://www.softlab.ntua.gr/~nickie/Courses/progtech/
 * ---------------------------------------------------------------------
 */


/* Header files */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>


/* Constants */

#define MAX_TRIES 1000

#define M 10
#define N 20


/* Function that fills the table with random values between 0 and M */

void makeTable (int r[N][N])
{
    int i, j;

    for (i = 0; i < N; i++)
        for (j = 0; j < N; j++)
            r[i][j] = rand() % (M+1);
}


/* Main program */

int main ()
{
    int    r[N][N];
    double sumx, sumx2, m, sigma, maxsigma;
    int    i, j, count;

    /* Read maximum standard deviation */

    printf("Please, give maximum allowed standard deviation: ");
    scanf("%lf", &maxsigma);

    count = 0;     /* counting the number of tries */

    do {
        /* Fill the table */

        makeTable(r);

        /*
            Calculate average (m) and standard deviation (sigma).
            Take advantage of the following transformation:

            m = sum(x) / N^2

            sigma = sqrt(sum((x - m)^2) / N^2)
                  = sqrt(sum(x^2 - 2 x m + m^2) / N^2)
                  = sqrt((sum(x^2) - 2 m sum(x) + N^2 m^2) / N^2)
                  = sqrt((sum(x^2) - 2 N^2 m^2 + N^2 m^2) / N^2)
                  = sqrt(sum(x^2) / N^2 - m^2)
        */

        sumx = sumx2 = 0;

        for (i = 0; i < N; i++)
            for (j = 0; j < N; j++) {
                int x = r[i][j];

                sumx += x;
                sumx2 += x * x;
            }

        m = sumx / (N*N);
        sigma = sqrt(sumx2 / (N*N) - m*m);

        /* Repeat if necessary */

    } while (sigma >= maxsigma && ++count <= MAX_TRIES);

    /* Print the results */

    if (sigma < maxsigma) {
        for (i = 0; i < N; i++) {
            for (j = 0; j < N; j++)
                printf("%2d ", r[i][j]);
            printf("\n");
        }
    }
    else
        printf("Maximum number of tries reached...\n");

    return 0;
}
