/* Program: ex2-5.c
 * ---------------------------------------------------------------------
 * Solution to exercise 5, series 2.
 *
 * This program checks whether a given square matrix is symmetric
 * or triangular and prints appropriate messages.
 * ---------------------------------------------------------------------
 * Nikolaos S. Papaspyrou (nickie@softlab.ntua.gr)
 * National Technical University of Athens
 * Department of Electrical Engineering
 * ---------------------------------------------------------------------
 * Course: Programming Techniques (2nd semester)
 * URL:    http://www.softlab.ntua.gr/~nickie/Courses/progtech/
 * ---------------------------------------------------------------------
 */


/* Header files */

#include <stdio.h>


/* Constants */

#define N 5


/* Function to determine if a square matrix is symmetric */

int isSymmetric (int a[N][N])
{
    int i, j;

    for (i = 0; i < N-1; i++)
        for (j = i+1; j < N; j++)
            if (a[i][j] != a[j][i])
                return 0;
    return 1;
}


/* Function to determine if a square matrix is triangular
   The possible results are:
*/

#define NOT_TRIANGULAR   0
#define LOWER_TRIANGULAR 1
#define UPPER_TRIANGULAR 2
#define DIAGONAL         3

int isTriangular (int a[N][N])
{
    int lower, upper;
    int i, j;

    /* Check if lower triangular */

    lower = LOWER_TRIANGULAR;
    for (i = 0; i < N-1; i++)
        for (j = i+1; j < N; j++)
            if (a[i][j] != 0) {
                lower = 0;
                break;
            }

    /* Check if upper triangular */

    upper = UPPER_TRIANGULAR;
    for (i = 1; i < N; i++)
        for (j = 0; j < i; j++)
            if (a[i][j] != 0) {
                upper = 0;
                break;
            }

    /* Notice that (conveniently)
       DIAGONAL = LOWER_TRIANGULAR + UPPER_TRIANGULAR
    */

    return lower + upper;
}


/* Main program */

int main ()
{
    int a[N][N];
    int i, j;

    /* Read the matrix */

    printf("Please, give all elements of the matrix (%d by %d):\n", N, N);
    for (i = 0; i < N; i++)
        for (j = 0; j < N; j++)
            scanf("%d", &(a[i][j]));

    /* Check if symmetric */

    if (isSymmetric(a))
        printf("The matrix is symmetric\n");
    else
        printf("The matrix is not symmetric\n");

    /* Check if triangular */

    switch (isTriangular(a)) {
        case NOT_TRIANGULAR:
            printf("The matrix is not triangular\n");
            break;
        case LOWER_TRIANGULAR:
            printf("The matrix is lower triangular\n");
            break;
        case UPPER_TRIANGULAR:
            printf("The matrix is upper triangular\n");
            break;
        case DIAGONAL:
            printf("The matrix is diagonal (lower and upper triangular)\n");
            break;
    }

    return 0;
}
