/* Program: ex2-6.c
 * ---------------------------------------------------------------------
 * Solution to exercise 6, series 2.
 *
 * This program computes and prints the square root of a real number
 * with relative precision 10^-6, using Newton's method.
 * ---------------------------------------------------------------------
 * Nikolaos S. Papaspyrou (nickie@softlab.ntua.gr)
 * National Technical University of Athens
 * Department of Electrical Engineering
 * ---------------------------------------------------------------------
 * Course: Programming Techniques (2nd semester)
 * URL:    http://www.softlab.ntua.gr/~nickie/Courses/progtech/
 * ---------------------------------------------------------------------
 */


/* Header files */

#include <math.h>
#include <stdio.h>


/* Function to compute the square root of r with relative precision e,
   using Newton's method
*/

double mysqrt (double r, double e)
{
    double xnew = r / 2;
    double xprev;

    do {
        xprev = xnew;
        xnew = (xprev + r / xprev) / 2;
    } while (fabs(xnew - xprev) / xnew >= e);

    return xnew;
}


/* Main program */

int main ()
{
    double x, root;

    for (;;) {
        printf("Give a real number: ");
        scanf("%lf", &x);

        /* End program if a non-positive number is given */

        if (x <= 0)
            break;

        root = mysqrt(x, 1e-6);

        printf("The square root is %lf\n", root);
    }

    return 0;
}
